using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Units;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IReasonRepository
    {
        Task<BaseResult> Add(ReasonElastic reason);
        Task<BaseResult> AddManyAsync(IEnumerable<ReasonElastic> reasons);
        Task<SmartTableResult<ReasonElastic>> Search(BoolQueryDescriptor<ReasonElastic> query);
        Task<SmartTableResult<ReasonElastic>> GetByIds(List<long> ids);
        Task<SmartTableResult<ReasonElastic>> GetAll();

    }
    public class ReasonRepository : IReasonRepository
    {
        private readonly ElasticIndex<ReasonElastic> _dbContext;

        public ReasonRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<ReasonElastic>(settings.Value.ClusterUrl, "inventoryreason");
        }


        public async Task<SmartTableResult<ReasonElastic>> Search(BoolQueryDescriptor<ReasonElastic> query)
        {
            return await _dbContext.Search(query);
        }


        public async Task<BaseResult> Add(ReasonElastic reason)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(reason);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<ReasonElastic> reasons)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(reasons);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<SmartTableResult<ReasonElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<ReasonElastic>();
            var idsQ = new QueryContainerDescriptor<ReasonElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }
        public async Task<SmartTableResult<ReasonElastic>> GetAll()
        {
            var query = new BoolQueryDescriptor<ReasonElastic>();
            var isdeletedQ = new QueryContainerDescriptor<ReasonElastic>();
            isdeletedQ.Terms(t => t.Field(f => f.IsDeleted).Terms(false));
            query.Filter(f => isdeletedQ);
            return await _dbContext.Search(query);
        }
    }
}
